<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>JavaScript HW 1</title>
</head>
<body>
<script>
    "use strict";

    let userName = prompt("Please, enter your name below:", "");
    while (!isNaN(userName) || userName === "null") {
        userName = prompt("Please, re-enter the name:", userName);
    }

    let userAge = prompt("Please, enter your age below:", "");
    while (isNaN(+userAge) || userAge > 100 || userAge < 1) {
        userAge = prompt("Please, re-enter the age correctly", userAge);
    }

    if (userAge >= 18 && userAge <= 22) {
        if (confirm("Are you sure you want to continue?")) {
            alert("Welcome, " + userName + "!");
        } else {
            alert("You are not allowed to visit this website!");
        }
    } else if (userAge > 22) {
        alert("Welcome, " + userName + "!");
    } else {
        alert("You are not allowed to visit this website!");
    }
</script>

<!--=================================================================================================================-->
<article style="font-size: 20px; margin: 40px; text-align: justify;">
<h1>var, let, const - это ключевые слова для обьявления переменных в скриптах</h1>

<p>Обьявление переменной с использованием var - это стандарт, который действовал раньше, когда let и const еще не были
введены в качестве инструментов написания кода; то есть код, который написан до внедрения стандарта ES6, написан с
использованием var.</p>

<h2>Использование let и const - это практика, внедренная крайним стандартом, и, с моей точки зрения, призванная
добавить разработчику гибкости, а работе обьявленных им переменных - очевидности</h2>

<p>С помощью const обьявляется константная переменная, не подлежащая изменению в ходе выполения программы;
с помощью let обьявляются все остальные переменные.</p>

<p>Ключевое отличие - это область видимости var, let и const. В то время как область видимости let и const ограничена
(мы можем назначить переменную с таким же именем в цикле/{} и она будет локальной для этого цикла), область
видимости var не ограничивается ничем.</p>
	
<p>Обьявлять переменную с помощью var может считаться плохим тоном как по той причине, что выученым на стандарте ES6
программистам будет сложнее поддерживать такой код, так и по той же причине, что и использование в html-разметке тега
"div" в тех случаях, когда нужно использовать семантически подходящие "header", "main" или "aside".</p>

<details>
<summary>Скрытый текст:</summary>
<p>Использование var остается технически возможным, а потому знать функционал этого инструмента необходимо;
скорее всего, из-за того, что написанные до внедрения ES6 программы нуждаются в техподдержке, и их работа не должна
быть прекращена только из-за того, что стандарт написания кода эволюционировал; но, возможно, не только поэтому -
допускаю, что var используется опытными разработчиками в каких-то исключительных случаях, когда семантика должна
быть принесена в жертву логике программы или удобству разработки.</p>
</details>
</article>
<!--=================================================================================================================-->
</body>
</html>